unit AssocSel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ATShell,FileCtrl, ExtCtrls;

type
  TAddByTypeForm = class(TForm)
    ListBox1: TListBox;
    ATShell1: TATShell;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure LoadFileTypes;
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      aRect: TRect; State: TOwnerDrawState);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     Selection:string;
  end;

var
  AddByTypeForm: TAddByTypeForm;

implementation
 Uses RegWork,shellObj,Shellapi,CommCtrl;
{$R *.DFM}

procedure TAddByTypeForm.LoadFileTypes;
var
  blist:tstringlist;
  alist:tstrings;
  i:integer;
  s,s1:string;
begin
      blist:=tstringlist.create;
      blist.sorted:=true;
      blist.Duplicates := dupIgnore;
      alist:=AtShell1.EnumAllAssoc;
    try
      for i:=0 to alist.count-1 do
            begin
                  Atshell1.extension:=alist[i];
                  if Atshell1.GetAssociation then
                    begin
                      s:=Atshell1.PathToApp;
                      if (s<>'') then
                      begin
                        s1:=Atshell1.ReadType;
                        if s1<>'' then
                          begin
                            s1:=s1+';'+{Atshell1.IconPath}alist[i];
                            blist.add(s1);
                          end;
                      end;


                    end;
                end;
    finally
      alist.free;
      if blist.count>0 then
        Listbox1.items.addstrings(blist);
      blist.free;
    end;

end;


function GetCommandStr(instr:string):string;
   var
     e:integer;
    begin
      result:='';
      e:=pos(';',instr);
      if e<>0 then
         result:=copy(instr,e+1,length(instr));
    end;


 function GetTypeStr(instr:string):string;
   var
     e:integer;
    begin
      result:='';
      e:=pos(';',instr);
      if e<>0 then
         result:=copy(instr,1,e-1);
    end;

procedure TAddByTypeForm.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; aRect: TRect; State: TOwnerDrawState);
var
  R,Temp: TRect;
  ItemStr: String;
  ico:tpicture;


begin

  with (Control as TListBox) do
    begin
      if (odGrayed in State) or (odDisabled in State) then
        Canvas.Font.Color := clGrayText;
       ico:=tpicture.create;
       try
       Atshell1.extension:=GetCommandStr(items[index]);
       ico.icon.handle:=Atshell1.ReadIcon.handle;

      R := aRect;
      Canvas.TextRect(R, R.Left, R.Top, '                                           ');
      Temp :=aRect;
      Temp.left:=temp.left+4;
      Temp.Right := Temp.Left + (Temp.Bottom - Temp.Top);

      Canvas.draw(arect.left+2,arect.top+2,ico.icon);
      r.left:=temp.right;
        ItemStr:=GetTypeStr(items[index]);
      Canvas.TextRect(R, R.Left + 2, R.Top+((ListBox1.itemheight div 2)-(canvas.textheight('W') div 2)), Itemstr);
    finally
      ico.free;
     end;
   end;
end;

procedure TAddByTypeForm.ListBox1MeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
var
  i:integer;
begin
 with (Control as TListBox) do
  begin
     i:=Canvas.Textheight('W');
{   if i<small.height then
     Height:=small.height+2
   else
     Height:=i+2;}
    if i<36 then
      itemHeight:=36
    else
      itemHeight:=i;

   end;

   Height:=ListBox1.itemheight;
end;

procedure TAddByTypeForm.FormCreate(Sender: TObject);
begin
  screen.cursor:=crHourglass;
     selection:='';
     LoadFileTypes;
     Label2.caption:=selection;
   screen.cursor:=crdefault;

end;

procedure TAddByTypeForm.ListBox1DblClick(Sender: TObject);
begin
  Button1.click;
end;

procedure TAddByTypeForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   canclose:=true;
   if modalresult=mrOk then
    begin
     if listbox1.itemindex>-1 then
      Selection:=GetCommandStr(Listbox1.items[listbox1.itemindex])
     else
      canclose:=false;
    end;
end;

procedure TAddByTypeForm.ListBox1Click(Sender: TObject);
begin
 with ListBox1 do
  begin
    Atshell1.extension:=GetCommandStr(items[itemindex]);
    Selection:=Atshell1.extension;
    Label2.caption:=uppercase(selection);
  end;
end;

end.
